﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;
using MVR.FileManagementSecure;
using UnityEngine.UI;

namespace JayJayWon
{
    public class Settings
    {

        public static JSONStorableFloat maxButtonsPerPageJSF = new JSONStorableFloat("Max Resources Per Page",200f,MaxButtonsPerPageCallback, 20f,2000f);
        public static JSONStorableFloat uiScaleJSF = new JSONStorableFloat("Desktop UI Scale", 1f, UIScaleCallback, 0.5f, 2f);

        public Settings()
        {
            
        }

        private static void MaxButtonsPerPageCallback(float val)
        {
            maxButtonsPerPageJSF.valNoCallback = Mathf.Round(val / 10f) *10f;
            if (BrowserAssist.browserUI!=null && BrowserAssist.browserUI.resourceBrowserUI != null && BrowserAssist.browserUI.isUIActive) BrowserAssist.browserUI.RefreshButtonLayout();
            SaveSettings();
        }

        private static void UIScaleCallback(float val)
        {
            BrowserAssist.browserUI.RefreshScale();
            SaveSettings();
        }
        private static void SettingsBoolChange(bool val)
        {
            SaveSettings();
        }

        private static void SettingsFloatChange(float val)
        {
            SaveSettings();
        }

        private static void SaveSettings()
        {
            JSONClass settingsJC = new JSONClass();

            settingsJC["DesktopSettings"]["uiScale"].AsFloat = uiScaleJSF.val;
            settingsJC["BrowserSettings"]["maxButtonsPerPage"].AsFloat = maxButtonsPerPageJSF.val;

            SuperController.singleton.SaveJSON(settingsJC, Const.BAScriptDataFolder + "\\" + "BASettings.cfg");
        }

        public static void LoadSettings()
        {
            if (FileManagerSecure.FileExists(Const.BAScriptDataFolder + "\\" + "BASettings.cfg"))
            {
                JSONClass settingsJC;
                try
                {
                    settingsJC = SuperController.singleton.LoadJSON(Const.BAScriptDataFolder + "\\" + "BASettings.cfg").AsObject;
                }
                catch
                {
                    Utils.LogDebug("Settings.LoadSettings: Error during load of settings config file. Possible malformed JSON");
                    return;
                }

                if (settingsJC["DesktopSettings"]["uiScale"] != null) uiScaleJSF.val = settingsJC["DesktopSettings"]["uiScale"].AsFloat;
                if (settingsJC["BrowserSettings"]["maxButtonsPerPage"] != null) maxButtonsPerPageJSF.val = settingsJC["BrowserSettings"]["maxButtonsPerPage"].AsFloat;
            }

            
           
        }
    }

}
